﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Net;
using System.Threading.Tasks;
using System.Web.Http;
using System.Web.Http.SelfHost;
using System.Windows.Forms;

namespace SingleInstanceApplication
{
    static class Program
    {
        [STAThread]
        static void Main()
        {
            string[] args = Environment.GetCommandLineArgs();
            Process thisProc = Process.GetCurrentProcess();
            // Check how many total processes have the same name as the current one
            if (Process.GetProcessesByName(thisProc.ProcessName).Length > 1)
            {
                WebRequest req = WebRequest.Create("http://localhost:19002/Communication/AddItem/" + args[1]);
                req.Method = "GET";
                HttpWebResponse resp = req.GetResponse() as HttpWebResponse;
            }
            else {

                var config = new HttpSelfHostConfiguration("http://localhost:19002");
                config.Routes.MapHttpRoute(
                    name: "API",
                    routeTemplate: "{Controller}/{action}/{Item}",
                    defaults: new { item = RouteParameter.Optional }
                    );

                using (HttpSelfHostServer server = new HttpSelfHostServer(config))
                {
                    server.OpenAsync().Wait();
                    Application.EnableVisualStyles();
                    Application.SetCompatibleTextRenderingDefault(false);
                    Form1 frm1 = new Form1();
                    CommonObjects.objRef = frm1;
                    Application.Run(frm1);
                }
            }
        }
    }
}
